// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "demo.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif



extern BOOL NFGA_INIT();
extern BOOL NFGA_LOADDATA(LPSTR);
extern BOOL NFGA_LOADNET(LPSTR);
extern BOOL NFGA_FORECAST();
extern BOOL NFGA_SAVEFORECAST(LPSTR);
extern BOOL NFGA_EXIT();


//defined in NFGA.C
//extern BOOL FAR PASCAL NFGA_LOADDATA(LPSTR DataFileName);
//extern BOOL FAR PASCAL NFGA_LOADNET(LPSTR NetFileName);
//extern BOOL FAR PASCAL NFGA_SAVEFORECAST(LPSTR ResultFileName);
//extern BOOL FAR PASCAL NFGA_FORECAST();    
//extern BOOL FAR PASCAL NFGA_EXIT();

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_EmptyBox, OnEmptyBox)
	ON_COMMAND(ID_FilledBox, OnFilledBox)
	ON_COMMAND(ID_Retain, OnRetain)
	ON_COMMAND(ID_1LoadData, On1LoadData)
	ON_COMMAND(ID_2LoadNet, On2LoadNet)
	ON_COMMAND(ID_3Forecast, On3Forecast)
	ON_COMMAND(ID_4SaveResult, On4SaveResult)
	ON_COMMAND(ID_Exit, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,			// status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;		// fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;		// fail to create
	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnEmptyBox()
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnFilledBox()
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnRetain()
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::On1LoadData()
{
	//enter data file name here
	//more data files can be found in the DATA directory of NFGA

    //1. supply a fixed data file name here
	//NFGA_LOADDATA("AMETEK.DAT");

	//2. or ask user to supply a data file name
	CFileDialog FileDlg(TRUE);
	FileDlg.m_ofn.lpstrFilter="Data(*.dat,*.txt)\0*.dat *.txt\0All(*.*)\0*.*\0\0";

	if(FileDlg.DoModal() == IDOK){

		//pass the data file name
		BeginWaitCursor();
		NFGA_LOADDATA((LPSTR)(const char *)FileDlg.GetPathName());
		EndWaitCursor();			
	}	
}

void CMainFrame::On2LoadNet()
{
	//enter network file name
	//more neural network files can be found the FORECAST.ER direcotr of NFGA
    //1. supply a fixed net file name here
	//NFGA_LOADNET("AMETEK.GA");
	//2. or ask user to supply one
	CFileDialog FileDlg(TRUE);
	FileDlg.m_ofn.lpstrFilter="Net(*.net,*.ga,*ft,*.t)\0*.net *.ga *.ft *.t *.s\0All(*.*)\0*.*\0\0";

	if(FileDlg.DoModal() == IDOK){

		//pass the net file name
		BeginWaitCursor();
		NFGA_LOADNET((LPSTR)(const char *)FileDlg.GetPathName());
		EndWaitCursor();			
	}	
}

void CMainFrame::On3Forecast()
{
	// TODO: Add your command handler code here
	
	NFGA_FORECAST();
}

void CMainFrame::On4SaveResult()
{
	//enter result file name
	//1. use fixed result file name
	//NFGA_SAVEFORECAST("AMETEK.OUT");
	//2. or ask user to supply one
	CFileDialog FileDlg(FALSE);
	FileDlg.m_ofn.lpstrFilter="Net(*.out)\0*.out\0All(*.*)\0*.*\0\0";

	if(FileDlg.DoModal() == IDOK){

		//pass the result file name
		BeginWaitCursor();
		NFGA_SAVEFORECAST((LPSTR)(const char *)FileDlg.GetPathName());
		EndWaitCursor();			
	}	
}

void CMainFrame::OnExit()
{
	// TODO: Add your command handler code here

	//free memory before exit
	NFGA_EXIT();

	//PostQuitMessage(NULL);
	OnClose();	
}
